package com.seongjoo.aimsystem.guitar;

import java.util.List;

public class AIMGuitarTest {
	private static int testTotalCount;
	private static int testFailCount;

	public static void main(String[] args) {
		testTotalCount = 0;
		testFailCount = 0;
		
		// 기타 창고(Inventory) 객체 생성
			// TODO: 기타 창고 객체는 여러 개가 생성될 수 있는가?
		Inventory inventory = new Inventory();
		// 현악기 모의 재고 추가
		initializeInventory(inventory);
		
		// 악기 검색 기능 확인
		testTotalCount++;
		
		GuitarSpec queryGuitarSpec = new GuitarSpec();
		queryGuitarSpec.setBuilder("Fender");
		List<Guitar> resultGuitars = inventory.search(queryGuitarSpec);
		
		// 테스트 결과 확인
		if(resultGuitars.isEmpty()) testFailCount++;
		for(Guitar guitar : resultGuitars){
			GuitarSpec spec = guitar.getSpec();
			if(!spec.getBuilder().equals("Fender")){
				// 정보가 맞지 않음!
				testFailCount++;
				break;
			}
		}
		
		testTotalCount++;
		
		MandolinSpec queryMandolinSpec = new MandolinSpec();
		queryMandolinSpec.setStyle(Style.A);
		List<Mandolin> resultMandolins = inventory.search(queryMandolinSpec);
		
		// 테스트 결과 확인
		if(resultMandolins.isEmpty()) testFailCount++;
		for(Mandolin mandolin : resultMandolins){
			MandolinSpec spec = mandolin.getSpec();
			if(spec.getStyle() != Style.A){
				testFailCount++;
				break;
			}
		}
		
		// TODO: 기타 창고에 기타 추가하기
			// TODO: 여러 개의 기타 추가하기?
			// TODO: 중복된 기타를 추가하면?
		
		// TODO: 특정 기타를 창고에서 제거하기
	
		displayTestResult();
	}
	
	/**
	 * 
	 * @param inventory
	 */
	public static void initializeInventory(Inventory inventory){
		// 기타 재고 추가
		inventory.addInstrument(new Guitar("V95693", 1499.55, "Fender",
				"", "electric", Wood.ALDER, Wood.ALDER, 8));
		inventory.addInstrument(new Guitar("V85693", 1599.55, 
				"Fender", "", "electric", Wood.MAPLE, Wood.PINE, 5));
		
		// 만돌린 재고 추가
		inventory.addInstrument(new Mandolin("M1234", 1299.0, 
				"SJ", "classic", "", Wood.MAPLE, Wood.PINE, Style.A));
		inventory.addInstrument(new Mandolin("M2345", 1399.0, 
				"JS", "classic", "", Wood.PINE, Wood.ALDER, Style.F));
		
	}
	
	private static void displayTestResult(){
		System.out.println("총 테스트: " + testTotalCount);
		System.out.println("테스트 실패: " + testFailCount);
	}

}
