package com.seongjoo.aimsystem.guitar;

public class GuitarSpec extends InstrumentSpec{
	private int numStrings;
	
	public GuitarSpec(){
		super();
	}
	
	public GuitarSpec(String builder, String model, 
			String type, Wood backWood, Wood topWood, int numStrings){
		
		super(builder, model, type, backWood, topWood);
		
		this.numStrings = numStrings;

	}
	
	public boolean match(GuitarSpec querySpec){
		
		// 악기 공통 사양 비교
		if(!super.match(querySpec)) return false;
		
		// 기타 사양 비교
		int numStrings = querySpec.getNumStrings();
		if(numStrings != 0 && this.numStrings != numStrings){
			return false;
		}
		
		return true;
	}

	public int getNumStrings() {
		return numStrings;
	}

	public void setNumStrings(int numStrings) {
		this.numStrings = numStrings;
	}
}
