package com.seongjoo.aimsystem.guitar;

public abstract class InstrumentSpec {
	private String builder; // 제조사
	private String model; // 모델명
	private String type; // 종류
	private Wood backWood; 
	private Wood topWood;
	
	public InstrumentSpec(){	}
	
	public InstrumentSpec(String builder, String model,
			String type, Wood backWood, Wood topWood){
		this.builder = builder;
		this.model = model;
		this.type = type;
		this.backWood = backWood;
		this.topWood = topWood;		
	}
	
	public boolean match(InstrumentSpec querySpec){
		String builder = querySpec.getBuilder();
		if(builder != null && !builder.equals("") && !this.builder.equals(builder)){
			return false;
		}
		
		String model = querySpec.getModel();
		if(model != null && !model.equals("") && !this.model.equals(model)){
			return false;
		}
		
		String type = querySpec.getType();
		if(type != null && !type.equals("") && !this.type.equals(type)){
			return false;
		}
		
		Wood backWood = querySpec.getBackWood();
		if(backWood != null && this.backWood != backWood){
			return false;
		}
		
		Wood topWood = querySpec.getTopWood();
		if(topWood != null && this.topWood != topWood){
			return false;
		}
		
		return true;
	}

	public String getBuilder() {
		return builder;
	}

	public void setBuilder(String builder) {
		this.builder = builder;
	}

	public String getModel() {
		return model;
	}

	public void setModel(String model) {
		this.model = model;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public Wood getBackWood() {
		return backWood;
	}

	public void setBackWood(Wood backWood) {
		this.backWood = backWood;
	}

	public Wood getTopWood() {
		return topWood;
	}

	public void setTopWood(Wood topWood) {
		this.topWood = topWood;
	}	
}
