package com.seongjoo.aimsystem.guitar;

import java.util.ArrayList;
import java.util.List;

public class Inventory {
	private final List<Instrument> instruments;
	
	public Inventory(){
		instruments = new ArrayList<Instrument>();
	}
	
	public void addInstrument(Instrument instrument){
		instruments.add(instrument);
	}
	public List<Mandolin> search(MandolinSpec querySpec){
		List<Mandolin> resultMandolins = new ArrayList<Mandolin>();
		
		for(Instrument targetInstrument : instruments){
			try{
				MandolinSpec spec = (MandolinSpec)targetInstrument.getSpec();
				
				if(!spec.match(querySpec)) continue;
				
				resultMandolins.add((Mandolin)targetInstrument);
			}catch(ClassCastException ex){
				continue;
			}
		}
		
		return resultMandolins;
	}
	
	public List<Guitar> search(GuitarSpec querySpec){
		// 결과로 반환할 기타 목록
		List<Guitar> resultGuitars = new ArrayList<Guitar>();
		
		// 인벤토리에 저장된 재고 기타 각 항목에 대한
		for(Instrument targetInstrument : instruments){
			
			try{
				// 현재 기타 사양이 검색 조건에 부합하는지 확인.
				GuitarSpec spec = (GuitarSpec)targetInstrument.getSpec();
				if(!spec.match(querySpec)){
					// 검색 조건에 부합하지 않음.
					continue;
				}
				
				// 검색 조건에 부합. 결과 목록에 추가
				resultGuitars.add((Guitar)targetInstrument);
			}catch(ClassCastException ex){
				continue;
			}
		}
		
		return resultGuitars;
		
	}
	
	public void removeItem(){
		
	}
	
	public void updateItem(){
		
	}
}
