package com.seongjoo.aimsystem.guitar;

public class MandolinSpec extends InstrumentSpec {
	private Style style;
	
	public MandolinSpec(){
		super();
	}
	
	public MandolinSpec(String builder, String model, String type,
			Wood backWood, Wood topWood, Style style) {
		super(builder, model, type, backWood, topWood);
		
		this.style = style;
	}
	
	public void setStyle(Style style){
		this.style = style;
	}
	
	public Style getStyle(){
		return this.style;
	}
	
	public boolean match(MandolinSpec querySpec) {
		if(!super.match(querySpec)) return false;
		
		Style style = querySpec.getStyle(); 
		if(style != null && this.style != style){
			return false;
		}
		
		return true;
	}

}
